//========================================================================================
//
//	File:				FWGConst.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWGCONST_H
#define FWGCONST_H

// ----- Macintosh Includes -----

#if defined(FW_BUILD_MAC) && !defined(__QUICKDRAW__)
#include <QuickDraw.h>
#endif

// ----- Windows Includes -----

#if defined(FW_BUILD_WIN) && !defined(_INC_WINDOWS)
#include <windows.h>
#endif

//==============================================================================
//	 Drawing Modes
//==============================================================================

typedef short	FW_TransferMode;

#ifdef FW_BUILD_WIN
const FW_TransferMode FW_kCopy				= R2_COPYPEN;
const FW_TransferMode FW_kNotCopy			= R2_NOTCOPYPEN;
const FW_TransferMode FW_kOr				= R2_MASKPEN;
const FW_TransferMode FW_kNotOr				= R2_MASKNOTPEN;
const FW_TransferMode FW_kXOr				= R2_XORPEN;
const FW_TransferMode FW_kNotXOr			= R2_NOTXORPEN;
const FW_TransferMode FW_kClear				= R2_MERGEPEN;
const FW_TransferMode FW_kNotClear			= R2_MERGENOTPEN;
#endif

#ifdef FW_BUILD_MAC
const FW_TransferMode FW_kCopy				= patCopy;
const FW_TransferMode FW_kNotCopy			= notPatCopy;
const FW_TransferMode FW_kOr				= patOr;
const FW_TransferMode FW_kNotOr				= notPatOr;
const FW_TransferMode FW_kXOr				= patXor;
const FW_TransferMode FW_kNotXOr			= notPatXor;
const FW_TransferMode FW_kClear				= patBic;
const FW_TransferMode FW_kNotClear			= notPatBic;
#endif

//==============================================================================
//	 Font Name
//==============================================================================

#ifdef FW_BUILD_MAC
const char* FW_kSystemFont				= "chicago";
const char* FW_kDefaultFont			= "helvetica";
const char* FW_kHelvetica				= "helvetica";
#endif

//==============================================================================
//	 Font Style
//==============================================================================

enum FW_FontStyle
{
	FW_kPlain 			= 0x0000,
	FW_kBold 			= 0x0001,
	FW_kItalic 			= 0x0002,
	FW_kUnderline 		= 0x0004,
	FW_kStrikeThrough 	= 0x0008,
	FW_kOutline 		= 0x0010,
	FW_kShadow 			= 0x0020,
	FW_kExtended 		= 0x0040,
	FW_kCondensed 		= 0x0080
};

//==============================================================================
//	 Shape Type
//==============================================================================

enum FW_ShapeCategory
{
	FW_kGeometricShape,
	FW_kTypographicShape,
	FW_kBitmapShape,
	FW_kPictureShape
};

//==============================================================================
//	 Shape Fills
//==============================================================================

enum FW_ShapeFills {
	FW_kNullShape,
	FW_kFramed,
	FW_kDashFramed,
	FW_kFilled
};

//==============================================================================
//	 Hit Testing Part
//==============================================================================

enum FW_HitTestPart {
	FW_kOutside = 0,
	FW_kInBounds = 1,
	FW_kInGeometry = 2
};

//==============================================================================
//	 Justification
//==============================================================================

enum FW_Justification {
	FW_kFlushDefault,
	FW_kFlushCenter,
	FW_kFlushRight,
	FW_kFlushLeft
};

#endif