//========================================================================================
//
//	File:				FWGrUtil.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWGRUTIL_H
#define FWGRUTIL_H

#ifndef FWGRDEF_H
#include <FWGrDef.h>
#endif

// ----- OpenDoc Includes -----

#ifndef _XMPTYPES_
#include <XMPTypes.h>
#endif

#ifndef _PLFMDEF_
#include <PlfmDef.h>
#endif

// ----- Macintosh Includes -----

#if defined(FW_BUILD_MAC) && !defined(__QUICKDRAW__)
#include <QuickDraw.h>
#endif

#if defined(FW_BUILD_MAC) && !defined(__WINDOWS__)
#include <Windows.h>
#endif

#if defined(FW_BUILD_MAC) && !defined(__TEXTEDIT__)
#include <TextEdit.h>
#endif

//==============================================================================
//	 Forward Declarations
//==============================================================================

class XMPShape;
class XMPTransform;
struct FW_CPoint;
struct FW_CRect;

//==============================================================================
//	 Global Utilities
//==============================================================================

// ----- Graphic Initialization -----
void InitGraphic();

// ----- XMPShape utilities
void		InsetXMPShape(XMPShape *shape, short xInset, short yInset);
void 		GetXMPShapeQDBox(XMPShape *shape, FW_SPlatformRect& box);

XMPShape*	NewXMPShape();
XMPShape*	NewXMPShape(XMPShape* otherShape);
XMPShape*	NewXMPShape(const FW_CRect& rect);
XMPShape*	NewXMPShape(const FW_SPlatformRect& rect);
XMPShape*	NewXMPShape(FW_PlatformRegion rgn);

// ----- XMPTransform utilities
XMPTransform* 	NewXMPTransform();
XMPTransform* 	NewXMPTransform(XMPTransform* otherTransform);
XMPTransform* 	NewXMPTransform(const FW_CPoint& offset);

//==============================================================================
//	 Macintosh Utilities
//==============================================================================

#ifdef FW_BUILD_MAC
void 		GetPortTextStyle(TextStyle& theTextStyle);
void 		SetPortTextStyle(const TextStyle& theTextStyle);
#endif

#endif