//========================================================================================
//
//	File:				FWWinPen.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWWINPEN_H
#define FWWINPEN_H

#ifndef FWWINGDI_H
#include "FWWinGDI.h"
#endif

#ifndef FWCOLOR_H
#include "FWColor.h"
#endif

#ifndef FWINK_H
#include "FWInk.h"
#endif

#ifndef FWSTYLE_H
#include "FWStyle.h"
#endif

#ifdef FW_BUILD_WIN

//========================================================================================
//	 CLASS FW_CWinPen
//========================================================================================

class FW_CWinPen : public FW_CGraphicObjectPtr
{

//----------------------------------------------------------------------------------------
//	 Constructors
//
public:
	FW_CWinPen();
	FW_CWinPen(FW_CInk ink, FW_CStyle style);
	FW_CWinPen(const FW_CWinPen& otherPen);
			
protected:
	FW_CWinPen(FW_CWinPenRep* rep);
		// Creates a pointer pointing at rep.

//----------------------------------------------------------------------------------------
//	 Operators
//
public:
	FW_CWinPen& operator=(const FW_CWinPen& other);
		// Assignment, point this pointer to the same rep as the other pointer points to.
		
	FW_CWinPenRep* operator->() const
				{return (FW_CWinPenRep*)GetRep();}
		// Provide access to members of rep.	
};

//========================================================================================
//	 CLASS FW_CWinPenRep
//========================================================================================

class FW_CWinPenRep : public FW_CWinGDIObjectRep
{

//------------------------------------------------------------------------------
//	 Constructors/Destructors
//
public:
	virtual ~FW_CWinPenRep();

protected:
	FW_CWinPenRep();
	FW_CWinPenRep(const FW_CWinPenRep& shapeRep);
	FW_CWinPenRep(FW_CInk ink, FW_CStyle style);


};

#endif

#endif